# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12 ]) => {
    return {
        $class: "io.clause.demo.fragileGoods.TemplateModel",
        
        deliveryPrice : rule9,
        accelerationMin : rule3,
        accelerationMax : rule5,
        accelerationBreachPenalty : rule7,
        deliveryLimitDuration : rule11,
        lateDeliveryPenalty : rule1
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "6.1.7 Liquidated Damages for Delayed Delivery. \nIn the event the EXW delivery date of the Equipment is delayed beyond the delivery schedule as indicated in Annex A, solely through the fault of the Seller, and unless the parties mutually agreed to an extension thereto, the Buyer is entitled to claim liquidated damages in an amount equivalent to " 


rule1 -> MonetaryAmount {% id %} # lateDeliveryPenalty 


rule2 -> ". \nPrior to implementing the provisions of Article 16.4 pursuant to this section, Buyer agrees that it shall discuss with Seller alternate remedies in good faith.. . . . \n\n7.1 The Equipment to be shipped to the Buyer shall be packed and shipped in accordance with the Specifications and if not specified therein.... \nAdditionally the Equipment should have proper devices on it to record any shock during transportation as any instance of acceleration outside the bounds of " 


rule3 -> Double {% id %} # accelerationMin 


rule4 -> "g and " 


rule5 -> Double {% id %} # accelerationMax 


rule6 -> "g. \nEach shock shall reduce the Contract Price by " 


rule7 -> MonetaryAmount {% id %} # accelerationBreachPenalty 


rule8 -> ". Packing containing fragile materials should be so marked in bold stout letters. . . . .\n\nANNEX A\nEquipment Description, Contract Price and Delivery Schedule\n\nContract Price is " 


rule9 -> MonetaryAmount {% id %} # deliveryPrice 


rule10 -> " per unit of Equipment.\nDelivery Schedule: no later than " 


rule11 -> Duration {% id %} # deliveryLimitDuration 


rule12 -> " after initiation.\n" 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


ShipmentStatus -> "CREATED" {% id %} | "IN_TRANSIT" {% id %} | "ARRIVED" {% id %} 


DeliveryUpdate -> DateTime  __  DateTime:?  __  ShipmentStatus  __  Double:+  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "io.clause.demo.fragileGoods.DeliveryUpdate",
        startTime : data[0],
        finishTime : data[2],
        status : data[4],
        accelerometerReadings : data[6],
        transactionId : data[8],
        timestamp : data[10]
    };
}
%}


PayOut -> MonetaryAmount  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "io.clause.demo.fragileGoods.PayOut",
        amount : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


TemporalUnit -> "seconds" {% id %} | "minutes" {% id %} | "hours" {% id %} | "days" {% id %} | "weeks" {% id %} | "years" {% id %} 


Duration -> Long  __  TemporalUnit 

{% ( data ) => {
    return {
        $class: "org.accordproject.time.Duration",
        amount : data[0],
        unit : data[2]
    };
}
%}


MonetaryAmount -> Double  __  CurrencyCode 

{% ( data ) => {
    return {
        $class: "org.accordproject.money.MonetaryAmount",
        doubleValue : data[0],
        currencyCode : data[2]
    };
}
%}


CurrencyCode -> "AED" {% id %} | "AFN" {% id %} | "ALL" {% id %} | "AMD" {% id %} | "ANG" {% id %} | "AOA" {% id %} | "ARS" {% id %} | "AUD" {% id %} | "AWG" {% id %} | "AZN" {% id %} | "BAM" {% id %} | "BBD" {% id %} | "BDT" {% id %} | "BGN" {% id %} | "BHD" {% id %} | "BIF" {% id %} | "BMD" {% id %} | "BND" {% id %} | "BOB" {% id %} | "BOV" {% id %} | "BRL" {% id %} | "BSD" {% id %} | "BTN" {% id %} | "BWP" {% id %} | "BYN" {% id %} | "BZD" {% id %} | "CAD" {% id %} | "CDF" {% id %} | "CHE" {% id %} | "CHF" {% id %} | "CHW" {% id %} | "CLF" {% id %} | "CLP" {% id %} | "CNY" {% id %} | "COP" {% id %} | "COU" {% id %} | "CRC" {% id %} | "CUC" {% id %} | "CUP" {% id %} | "CVE" {% id %} | "CZK" {% id %} | "DJF" {% id %} | "DKK" {% id %} | "DOP" {% id %} | "DZD" {% id %} | "EGP" {% id %} | "ERN" {% id %} | "ETB" {% id %} | "EUR" {% id %} | "FJD" {% id %} | "FKP" {% id %} | "GBP" {% id %} | "GEL" {% id %} | "GHS" {% id %} | "GIP" {% id %} | "GMD" {% id %} | "GNF" {% id %} | "GTQ" {% id %} | "GYD" {% id %} | "HKD" {% id %} | "HNL" {% id %} | "HRK" {% id %} | "HTG" {% id %} | "HUF" {% id %} | "IDR" {% id %} | "ILS" {% id %} | "INR" {% id %} | "IQD" {% id %} | "IRR" {% id %} | "ISK" {% id %} | "JMD" {% id %} | "JOD" {% id %} | "JPY" {% id %} | "KES" {% id %} | "KGS" {% id %} | "KHR" {% id %} | "KMF" {% id %} | "KPW" {% id %} | "KRW" {% id %} | "KWD" {% id %} | "KYD" {% id %} | "KZT" {% id %} | "LAK" {% id %} | "LBP" {% id %} | "LKR" {% id %} | "LRD" {% id %} | "LSL" {% id %} | "LYD" {% id %} | "MAD" {% id %} | "MDL" {% id %} | "MGA" {% id %} | "MKD" {% id %} | "MMK" {% id %} | "MNT" {% id %} | "MOP" {% id %} | "MRU" {% id %} | "MUR" {% id %} | "MVR" {% id %} | "MWK" {% id %} | "MXN" {% id %} | "MXV" {% id %} | "MYR" {% id %} | "MZN" {% id %} | "NAD" {% id %} | "NGN" {% id %} | "NIO" {% id %} | "NOK" {% id %} | "NPR" {% id %} | "NZD" {% id %} | "OMR" {% id %} | "PAB" {% id %} | "PEN" {% id %} | "PGK" {% id %} | "PHP" {% id %} | "PKR" {% id %} | "PLN" {% id %} | "PYG" {% id %} | "QAR" {% id %} | "RON" {% id %} | "RSD" {% id %} | "RUB" {% id %} | "RWF" {% id %} | "SAR" {% id %} | "SBD" {% id %} | "SCR" {% id %} | "SDG" {% id %} | "SEK" {% id %} | "SGD" {% id %} | "SHP" {% id %} | "SLL" {% id %} | "SOS" {% id %} | "SRD" {% id %} | "SSP" {% id %} | "STN" {% id %} | "SVC" {% id %} | "SYP" {% id %} | "SZL" {% id %} | "THB" {% id %} | "TJS" {% id %} | "TMT" {% id %} | "TND" {% id %} | "TOP" {% id %} | "TRY" {% id %} | "TTD" {% id %} | "TWD" {% id %} | "TZS" {% id %} | "UAH" {% id %} | "UGX" {% id %} | "USD" {% id %} | "USN" {% id %} | "UYI" {% id %} | "UYU" {% id %} | "UZS" {% id %} | "VEF" {% id %} | "VND" {% id %} | "VUV" {% id %} | "WST" {% id %} | "XAF" {% id %} | "XAG" {% id %} | "XAU" {% id %} | "XBA" {% id %} | "XBB" {% id %} | "XBC" {% id %} | "XBD" {% id %} | "XCD" {% id %} | "XDR" {% id %} | "XOF" {% id %} | "XPD" {% id %} | "XPF" {% id %} | "XPT" {% id %} | "XSU" {% id %} | "XTS" {% id %} | "XUA" {% id %} | "XXX" {% id %} | "YER" {% id %} | "ZAR" {% id %} | "ZMW" {% id %} | "ZWL" {% id %} 



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}